300.leetcode-Longest Incresing Subsequence最长递增子序列

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

方法一:采用动态规划的思想,定义一个一维数组dp[i],表示以nums[i]结尾的最长递增子序列。遍历nums[i]之前的数,如果发现某个数小于nums[i],则更新dp[i], dp[i]=max(dp[i], dp[j]+1).返回dp数组的最大值。时间复杂度为O(n2).

class Solution {
public:
    int lengthOfLIS(vector<int>& nums) {
        int n = nums.size();
	if (n == 0)
		return 0;
	vector<int>dp(n, 1);
	int maxval=1;
	for (int i = 1; i<n; ++i)
	{
		for (int j = i - 1; j >= 0; --j)
		{
			if (nums[j] < nums[i])
				dp[i] = max(dp[i], dp[j] + 1);
		}
		if(dp[i]>maxval)
		maxval=dp[i];
	}
	return maxval;
    }
};
方法二:时间复杂度为O(nlogn).利用二分查找的思想。建立一个一维数组dp[i],开始遍历原数组,对每一个元素,用二分查找法找到第一个不小于它的的数字,如果这个数字不存在,则直接在后面添加该元素,如果存在,则将这个数字替换为当前遍历到的元素,最后返回dp的元素个数。注意:dp数组可能并不是一个真实的LIS.

int lengthOfLIS(vector<int>& nums) {
    vector<int> res;
    for(int i=0; i<nums.size(); i++) {
        auto it = std::lower_bound(res.begin(), res.end(), nums[i]);
        if(it==res.end()) res.push_back(nums[i]);
        else *it = nums[i];
    }
    return res.size();
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值